Last Comment Bug 69099 - Alt/F10/context menu item to make hidden menubar visible
: Alt/F10/context menu item to make hidden menubar visible
Status: NEW
: access
Product: SeaMonkey
Classification: Client Software
Component: UI Design (show other bugs)
: Trunk
: All All
-- enhancement with 8 votes (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
: sairuh (rarely reading bugmail)
:
Mentors:
: 128406 137004 142105 144318 (view as bug list)
Depends on:
Blocks: uaag 26353 135841
  Show dependency treegraph
 
Reported: 2001-02-16 12:16 PST by sean echevarria
Modified: 2016-05-16 08:34 PDT (History)
25 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments

Description User image sean echevarria 2001-02-16 12:16:07 PST
I hate it when a site opens up a popup window and hides the menubar in it.  I'd 
like to be able to rt-click in the window and enable the menubar from the 
context menu.
Comment 1 User image timeless 2001-02-16 13:40:03 PST
would it be ok if we put it in the system menu? [i don't know if all os's allow 
this] [macos probably doesn't care]
Comment 2 User image sean echevarria 2001-02-16 20:52:23 PST
available anywhere, doesn't matter where.  Doesn't even necessarily have to be 
on a menu of any sort - a pref with no ui where you can specify a key 
combination to toggle the menubar would work.
Comment 3 User image Ben Goodger (use ben at mozilla dot org for email) 2001-02-16 22:32:20 PST
use a user stylesheet to turn off the menubar in your build. 
Comment 4 User image sean echevarria 2001-02-17 11:45:39 PST
Why?

Comment 5 User image Hixie (not reading bugmail) 2001-02-18 06:16:51 PST
Ben: You misunderstood the bug. The problem isn't hiding the menu, it's showing
the menu once the menu has been hidden.
Comment 6 User image Keyser Sose 2001-02-21 01:33:44 PST
 Ahh Yes I like this idea immensly. It always pisses me off when I cant use
Context menu's in a site. Marking NEW and putting in Browser General because I
dont think its XP-Apps.
Comment 7 User image Asa Dotzler [:asa] 2001-02-21 09:57:21 PST
over to XPApps.
Comment 8 User image sairuh (rarely reading bugmail) 2001-02-21 11:37:21 PST
this would be useful, but i'd rather not have it in the context menu. i don't
mind have having this option in one of the main menus [prolly View] and/or
having a hidden pref.

recommend wontfix for the context menu aspect.
Comment 9 User image sean echevarria 2001-02-21 13:19:04 PST
I don't think an option to show the menubar would be of much help if it was in 
the menubar that was hidden.
Trying my hand at resummarizing.
Comment 10 User image sean echevarria 2001-02-21 13:20:24 PST
That's not meant to imply that the context menu is the right place either...
Comment 11 User image sairuh (rarely reading bugmail) 2001-02-21 13:27:26 PST
sean, heh, good point... hm, other than having a pref [hidden or otherwise],
methinks this might be a candidate for a keyboard shortcut. thoughts?
Comment 12 User image Jesse Ruderman 2001-02-21 14:53:11 PST
If the key can just show the menu (doesn't need to actually toggle the menu), 
F10 would work.
Comment 13 User image timeless 2001-02-21 15:08:51 PST
i like F 10.
Comment 14 User image sean echevarria 2001-02-21 15:55:42 PST
ditto
Comment 15 User image Jesse Ruderman 2001-02-25 20:23:52 PST
It might also be good to show the menubar if the user presses Alt (without 
pressing anything else while Alt is held down.)
Comment 16 User image Jesse Ruderman 2001-02-25 21:29:13 PST
Hmm, or Alt+F (or another menu mnemonic).
Comment 17 User image Blake Ross 2001-04-13 20:46:25 PDT
Matthew, comments?

-> markh, who did F10.  Mark, can you help out with expanding and showing 
menubars if these accelerators are pressed? (Doing it from C++ would be 
difficult; the expansion part might be impossible.  Then again, if we do it 
from the FE, we want this behavior for all menubars. Perhaps we can do it in 
the binding, if the menubar gets the keypress from anywhere...)
Comment 18 User image Matthew Paul Thomas 2001-04-15 14:12:05 PDT
Any mechanism offered has to be available from both the mouse and the keyboard, 
for accessibility reasons. `F10' won't cut it, especially on platforms where 
the function keys are reserved for OS use(ahem).

Here's what I suggest.

On Mac OS, the window.open flag to turn the menu bar off should have no effect 
at all. Now before standards compliance people (or people who think I'm giving 
the Mac special treatment) jump up and down, here's the explanation ... When 
authors use this flag, they're asking for a window without a menu bar *in it*. 
On Mac OS, that's what they always get anyway, so setting the flag should have 
no effect. (And indeed, on Internet Explorer for Mac OS the flag does have no 
effect.)

On other platforms, when the menu bar is turned off, there should be an item at 
the bottom of *every* context menu (not just the page context menu, but also 
the context menus for links, images, image links, and frames), saying `Show 
Menu Bar'. This does the obvious thing. And yes, I know this makes the context 
menus even longer, but (a) it's only for popups, and (b) I have a bug to clean 
out the trash from the context menus already.
Comment 19 User image Aaron Leventhal 2001-06-19 17:37:55 PDT
This isn't just about menus.

This is also about scroll bars being taken away. I have had times where I needed
to scroll a popup but couldn't.

There should be a way to get back any part of a window's chrome that you need -
be it the menu, status bar, close window, scroll bars, whatever.
Comment 20 User image Aaron Leventhal 2001-06-19 17:38:58 PDT
Adding access keyword, as this has been discussed by the W3C User Agent
Accessibilit group.
Comment 21 User image Tim Powell 2001-06-20 07:54:56 PDT
It would be cool if pressing Alt or Alt+MenuLetter would temporarily show the 
menubar and hide it again when a menu item has been activated or Esc pressed. 

It'd also be nice to permanently restore any missing chrome. As already noted, 
it's a bigger problem than just the menu. It's important to be able to restore 
(and I'd suggest toggle them off again, too) the menus, scrollbars, statusbar, 
toolbars, and locationbar.

I believe IE4 put this context menu in the application control menu (available 
from Alt+Spacebar and by clicking on the icon at the left end of the titlebar). 
IE5 seems to have removed the capability as near as I can tell.

Does this require some sort of pref to disable this capability for a kiosk 
mode? (I don't know if Mozilla supports a kiosk mode).
Comment 22 User image Dean Tessman 2001-06-20 12:52:58 PDT
Pressing Alt shouldn't show the menu bar.  This will be messy with access keys 
for HTML elements.  If I have a field named "_L_ast Name:", I need to press 
Alt+L to access that field.  Undoubtedly, I will press Alt before I press L.

As for context menus, what about sites that have eat the oncontextmenu event so 
that they are never displayed?
Comment 23 User image Tim Powell 2001-06-20 13:24:14 PDT
Sorry, I should have been clearer. When I said press Alt, I meant that it 
should trigger the menu on the release of Alt. Just like the File menu is 
normally highlighted after pressing and releasing Alt. Mozilla would certainly 
know whether the Alt+Letter combo was for a menu or accesskey. Only a combo for 
the menu would need to show the menu.
Comment 24 User image Aaron Leventhal 2001-07-19 16:01:25 PDT
Last time I checked, this would be a technique for a W3C User Agent Guideline.
The user is supposed to be able to stop UI from being removed by web content.
Comment 25 User image Jesse Ruderman 2001-08-01 20:00:00 PDT
See also bug 72001, pressing Alt+E while menu bar is collapsed makes it
impossible to click on the menu after uncollapsing the menu bar.
Comment 26 User image Jesse Ruderman 2001-09-08 21:10:21 PDT
See bug 81331, Ctrl+L should make location bar visible if it's hidden.
Comment 27 User image Jesse Ruderman 2002-03-02 17:40:48 PST
*** Bug 128406 has been marked as a duplicate of this bug. ***
Comment 28 User image Jesse Ruderman 2002-03-02 17:46:38 PST
I would prefer if the context menu item was "Show toolbars" instead of "Show 
menu bar".  Just showing the menu bar would be awkward, and I'm usually most 
interested in seeing the location bar.

Showing the menu bar (or other toolbars) should also turn on scrollbars if 
scrollbars were disabled for the window, because there's no menu item for 
toggling scrollbars and because the content is likely to need scrollbars once 
any chrome becomes visible.
Comment 29 User image Jesse Ruderman 2002-04-26 22:17:22 PDT
*** Bug 137004 has been marked as a duplicate of this bug. ***
Comment 30 User image Jesse Ruderman 2002-05-06 02:09:35 PDT
*** Bug 142105 has been marked as a duplicate of this bug. ***
Comment 31 User image Jesse Ruderman 2002-06-09 00:09:01 PDT
*** Bug 144318 has been marked as a duplicate of this bug. ***
Comment 32 User image Jonas Jørgensen 2002-06-09 03:03:44 PDT
Recommend wontfix since we now have prefs (see bug 107949) to prevent scripts
from hiding the menubar in the first place.
Comment 33 User image Jamie Zawinski 2002-06-09 12:45:07 PDT
That's silly.

I *do not* want all of my pop-up windows to have menubars.  That would just
clutter things unnecessarily.

And yet, in those rare occasions when I need to get at infrequently-used
commands on those popup windows (doc info, etc) I still want some way to get at
them.

(I agree that on a mac it might make sense to just never hide the menubar, but
I'm talking about unix.)
Comment 34 User image Aaron Leventhal 2002-06-09 14:32:46 PDT
Jamie, all of your popups wouldn't have menu bars - you would only get the menu
bars if you used a command to navigate to the menubar.
Comment 35 User image Jamie Zawinski 2002-06-09 14:38:37 PDT
Aaron Leventhal wrote:
>
> Jamie, all of your popups wouldn't have menu bars - you would only
> get the menu bars if you used a command to navigate to the menubar.

That sounds fine.  But I was replying to:

Jonas Jørgensen wrote:
>
> Recommend wontfix since we now have prefs (see bug 107949) to
> prevent scripts from hiding the menubar in the first place.

which I interpret as "if you ever want a popup to have a menu bar, then
set a preference to make them all always have menubars", which sounds
like a terrible idea.
Comment 36 User image jg 2002-11-06 19:13:43 PST
add JG
Comment 37 User image Kevin Ar18 2004-05-15 16:20:03 PDT
I believe that this feature should nto only be limited to the menubar, but it
should show all items that have been removed by the window.open command.
This includes, but is not limited to:
the menu
the toolbar(s)
the address bar
the status bar
the scroll bars

As such, a more descriptive context menu item may be necessary.
Some ideas:
"Restore window defaults"
"Show window tools"
"Restore window toolbars"

--------------------------
In addition to this, I also have several questions that I believe need to be
addressed.
1) Would it is also be equally useful to have a context menu option to restore
the window back to its original form (with whatever toolbars, and menubars that
were originally missing)?  Just like this feature we are proposing, it would
only apply to windows that were once a pop-up.
2) Of a more serious nature, what do we do when that window calls a close()
command in javascript?!
If the user started using that page to browse other sites on the internet, then
if he encountered (either accidentally or through a malicious website) a page
that calls window.close(), then he would suddenly have his window closed on him.
 This, of course, would not be a good thing.
In order to prevent these kinds of problems, I would think that the window
should no longer be allowed to close.  However, if we did this, would this cause
other problems that I am not familiar with? Would it affect W3C compliance? 
Should we not allow the user to restore all "chrome" features in the first place?
Comment 38 User image Kevin Ar18 2004-05-15 16:35:17 PDT
I just looked at Bug 26353, however I'm not sure of the difference between that
bug and this bug.
Here's what I made out:
This bug suggests adding a keyboard shortcut and context menu item, while Bug
26353 just suggests a context menu item.
This bug suggests an option to restore the menubar, while Bug 26353 suggests an
option to restore all the chrome items including the menubar.

Should both bugs exist?
Comment 39 User image Matthew Paul Thomas 2005-03-21 14:33:42 PST
Probably, because this bug is one of two open bugs genuinely blocking bug 26353.

Note You need to log in before you can comment on or make changes to this bug.